/* ------------------------------------------------------------------------- */
/*        ,                  */
/*     :                              */
/*   ..                                                             */
/*    . - .: -, 2012. - 384 . */
/*  ISBN 978-5-91359-102-9                                                   */
/*                                                                           */
/*     ,           */
/*                   */
/*   ,      .  */
/*                   */
/*  ,                 */
/*       .                                     */
/*     " ",            */
/*         .       */
/*                                                                           */
/*  Copyright  2008-2011  ..                                       */
/* ------------------------------------------------------------------------- */


#include <cstdio>

#include "../../common/zmatrix.hxx"

using namespace std;
using namespace z;

enum { NUM_ITER = 20 };

int main(int argc, char *argv[])
{
    //    u(x) - int(0, 1, x * y * u(y), dy) = 2/3 * x
    //   u(x) = x, x in [0, 1)
    const int n = 5000;

    // 
    matrix_type<double> a(n, n);
    for (int i = 0; i < a.vsize(); ++i)
        for (int j = 0; j < a.hsize(); ++j)
            a(i, j) = ((i + 0.5) / n) * ((j + 0.5) / n) / n;

    //   
    vector_type<double> f(n);
    for (int i = 0; i < f.vsize(); ++i)
        f(i) = 2.0 / 3.0 * (i + 0.5) / n;

    //   
    vector_type<double> u = f;
    //    
    for (int i = 0; i < NUM_ITER; ++i)
        u = a * u + f;

    //  
    for (int i = 0; i < u.vsize(); ++i)
        fprintf(stdout, "%f\n", u(i));
    return 0;
}
