/* ------------------------------------------------------------------------- */
/*        ,                  */
/*     :                              */
/*   ..                                                             */
/*    . - .: -, 2012. - 384 . */
/*  ISBN 978-5-91359-102-9                                                   */
/*                                                                           */
/*     ,           */
/*                   */
/*   ,      .  */
/*                   */
/*  ,                 */
/*       .                                     */
/*     " ",            */
/*         .       */
/*                                                                           */
/*  Copyright  2008-2011  ..                                       */
/* ------------------------------------------------------------------------- */


#include <mpi.h>
#include <cstdio>
#include <cstdlib>
#define _USE_MATH_DEFINES
#include <cmath>

using namespace std;

enum { MASTER_PROC_ID = 0 };

int main(int argc, char *argv[])
{
    int rc = 2;
    //  
    int n;

    //  MPI
    MPI_Init(&argc, &argv);

    //      
    if (argc == 2 && (n = strtol(argv[1], NULL, 0)) > 0)
    {
        int rank, size;
        //       
        MPI_Comm_size(MPI_COMM_WORLD, &size);
        MPI_Comm_rank(MPI_COMM_WORLD, &rank);

        //   
        double locsum = 0.0;
        double sum = 0.0;

        //   
        for (int i = rank; i < n; i += size)
            locsum += ((i & 1) ? - 1.0 : 1.0) / ((i << 1) | 1);

        MPI_Allreduce(
            &locsum, &sum, 1, MPI_DOUBLE,
            MPI_SUM, MPI_COMM_WORLD);
        sum *= 4.0;

        //     
        if (rank == MASTER_PROC_ID)
            fprintf(stdout, "%.16f\n", sum);

        //  
        rc = 0;
    }
    else
        fprintf(stderr, "error: iternum is not specified\n");

    MPI_Finalize();

    return rc;
}
