/* ------------------------------------------------------------------------- */
/*        ,                  */
/*     :                              */
/*   ..                                                             */
/*    . - .: -, 2012. - 384 . */
/*  ISBN 978-5-91359-102-9                                                   */
/*                                                                           */
/*     ,           */
/*                   */
/*   ,      .  */
/*                   */
/*  ,                 */
/*       .                                     */
/*     " ",            */
/*         .       */
/*                                                                           */
/*  Copyright  2008-2011  ..                                       */
/* ------------------------------------------------------------------------- */


#include <cstdio>
#include <cstdlib>
#include <cmath>

using namespace std;

double f(double x, double y)
{
    return sqrt(1.0 - x * x - y * y);
}

int main(int argc, char *argv[])
{
    int rc = 2;
    //  
    int n;
    //    
    double a = 1.0;

    //      
    if (argc == 2 && (n = strtol(argv[1], NULL, 0)) > 0)
    {
        double h = a / n, v = 0.0;

        for (int i = 0; i < n; ++i)
        {
            for (int j = 0; j <= i; ++j)
            {
                double x = (n - i - 0.5) * h;
                double y = (j + 0.5) * h;
                double s = h * h * ((j < i) ? 1.0 : 0.5);
                v += f(x, y) * s;
            };
        };

        fprintf(stdout, "%.16f\n", v);

        //  
        rc = 0;
    }
    else
        fprintf(stderr, "error: iternum is not specified\n");

    return rc;
}
