/* ------------------------------------------------------------------------- */
/*        ,                  */
/*     :                              */
/*   ..                                                             */
/*    . - .: -, 2012. - 384 . */
/*  ISBN 978-5-91359-102-9                                                   */
/*                                                                           */
/*     ,           */
/*                   */
/*   ,      .  */
/*                   */
/*  ,                 */
/*       .                                     */
/*     " ",            */
/*         .       */
/*                                                                           */
/*  Copyright  2008-2011  ..                                       */
/* ------------------------------------------------------------------------- */


#include <omp.h>
#include "../../common/synprintf.hxx"
using namespace z;

void process(int i)
{
    // ...
    synprintf(stdout, "Iter %d\n", i);
}

int main(int argc, char *argv[])
{
    int n = 100;

    //     
    //    
    if (omp_in_parallel() && !omp_get_nested())
    {
        //   
        for (int i = 0; i < n; ++i)
            process(i);
    }
    else
    {
        //    
        int num = omp_get_num_procs();
        //    
        omp_set_num_threads(num);
        //   
        #pragma omp parallel
        {
            //    
            #pragma omp single
            num = omp_get_num_threads();
            //      
            int id = omp_get_thread_num();
            //    
            //     
            for (int i = id; i < n; i += num)
                process(i);
        }
    }
    return 0;
}
