/* ------------------------------------------------------------------------- */
/*        ,                  */
/*     :                              */
/*   ..                                                             */
/*    . - .: -, 2012. - 384 . */
/*  ISBN 978-5-91359-102-9                                                   */
/*                                                                           */
/*     ,           */
/*                   */
/*   ,      .  */
/*                   */
/*  ,                 */
/*       .                                     */
/*     " ",            */
/*         .       */
/*                                                                           */
/*  Copyright  2008-2011  ..                                       */
/* ------------------------------------------------------------------------- */


#include <omp.h>
#include <map>
#include <list>
#include "../../common/synprintf.hxx"
using namespace z;

using namespace std;


int main(int argc, char *argv[])
{
    typedef int some_type;
    list<some_type> queue(omp_get_max_threads(), 0);
    map<int, some_type> store;

    omp_lock_t lockstore, lockqueue;
    omp_init_lock(&lockstore);
    omp_init_lock(&lockqueue);

    // ...

    #pragma omp parallel
    {
        // ...

        omp_set_lock(&lockstore);

        //     
        int id = store.size();

        omp_set_lock(&lockqueue);

        //      
        store[id] = queue.front();

        omp_unset_lock(&lockstore);

        //    
        queue.pop_front();

        omp_unset_lock(&lockqueue);

        // ...
    }

    // ...

    omp_destroy_lock(&lockstore);
    omp_destroy_lock(&lockqueue);

    return 0;
}
