/* ------------------------------------------------------------------------- */
/*        ,                  */
/*     :                              */
/*   ..                                                             */
/*    . - .: -, 2012. - 384 . */
/*  ISBN 978-5-91359-102-9                                                   */
/*                                                                           */
/*     ,           */
/*                   */
/*   ,      .  */
/*                   */
/*  ,                 */
/*       .                                     */
/*     " ",            */
/*         .       */
/*                                                                           */
/*  Copyright  2008-2011  ..                                       */
/* ------------------------------------------------------------------------- */


#ifdef _OPENMP
#include <omp.h>
#endif //_OPENMP

#include <cmath>
#include "../../common/synprintf.hxx"
using namespace z;

double func(double x)
{
    return 4.0 / (1.0 + x * x);
}

int main(int argc, char *argv[])
{
    //      
    double a = 0.0, b = 1.0;
    // 
    double eps = 0.0001;
    //   -  
    int n = 10;
    //   
    int iter = 0;
    //    
    double sum = 0.0, sumpre = 0.0;

    do
    {
        //  
        double h = (b - a) / n;
        //     
        sumpre = sum;
        sum = 0.0;
        #pragma omp parallel for reduction(+: sum)
        for (int i = 0; i < n; ++i)
        {
            //  
            double x = a + h * (i + 0.5);
            //   
            double f = func(x);
            //  
            sum += f * h;
        };
        //   
        n <<= 1;
        //    , 
    } while (iter++ == 0 || fabs(sum - sumpre) > eps);

    synprintf(stdout, "Result: %.16f, iterations: %d\n", sum, iter);
    return 0;
}
