/* ------------------------------------------------------------------------- */
/*        ,                  */
/*     :                              */
/*   ..                                                             */
/*    . - .: -, 2012. - 384 . */
/*  ISBN 978-5-91359-102-9                                                   */
/*                                                                           */
/*     ,           */
/*                   */
/*   ,      .  */
/*                   */
/*  ,                 */
/*       .                                     */
/*     " ",            */
/*         .       */
/*                                                                           */
/*  Copyright  2008-2011  ..                                       */
/* ------------------------------------------------------------------------- */


#include <sstream>
#include "zquantum.hxx"
#include "../../common/synprintf.hxx"


using namespace std;
using namespace z;
using namespace z::quantum;

int main(int argc, char *argv[])
{
    quantum_machine_type qm(3);
    qm.add_ternary(gate_toffoli_type(), 0, 1, 2);

    matrix_type<quantum_machine_type::element_type> mtx = qm.build_matrix();
    ostringstream ostr;
    ostr.setf(ios::fixed);
    for (int i = 0; i < mtx.vsize(); ++i)
    {
        for (int j = 0; j < mtx.hsize(); ++j)
            ostr << mtx(i, j) << " ";
        ostr << endl;
    };
    synprintf(stdout, "%s", ostr.str().c_str());

    return 0;
}
